﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Collections;
using MQTTnet;
using MQTTnet.Client;
using Newtonsoft.Json;

namespace ModbusDemo
{
    class startAddress
    {
        private ushort address;
        private ushort num;
        public ushort Address { get => address; set => address = value; }
        public ushort Num { get => num; set => num = value; }  
    }
    class WTDR18X
    {
        public string addr { get; set; }
        public double d0 { get; set; }
        public int d1 { get; set; }
        public int d2 { get; set; }
        public int d3 { get; set; }
        public int d4 { get; set; }
        public int d5 { get; set; }
        public int d6 { get; set; }
        public int d7 { get; set; }
        public UInt64 ts { get; set; }
        public WTDR18X(string addr, double d0, int d1, int d2, int d3, int d4, int d5, int d6, int d7, UInt64 ts)
        {
            this.addr = addr;
            this.d0 = d0;
            this.d1 = d1;
            this.d2 = d2;
            this.d3 = d3;
            this.d4 = d4;
            this.d5 = d5;
            this.d6 = d6;
            this.d7 = d7;
            this.ts = ts;
        }
    }
    class WTDR14P
    {
        public string addr { get; set; }
        public double d0 { get; set; }
        public int d1 { get; set; }
        public int d2 { get; set; }
        public int d3 { get; set; }
        public UInt64 ts { get; set; }
        public WTDR14P(string addr, double d0, int d1, int d2, int d3, UInt64 ts)
        {
            this.addr = addr;
            this.d0 = d0;
            this.d1 = d1;
            this.d2 = d2;
            this.d3 = d3;
            this.ts = ts;
        }
    }
    class WTDR66C
    {
        public string addr { get; set; }
        public int d0 { get; set; }
        public int d1 { get; set; }
        public int d2 { get; set; }
        public int d3 { get; set; }
        public int d4 { get; set; }
        public int d5 { get; set; }
        public UInt64 ts { get; set; }

        public WTDR66C(string addr, int d0, int d1, int d2, int d3, int d4, int d5, UInt64 ts)
        {
            this.addr = addr;
            this.d0 = d0;
            this.d1 = d1;
            this.d2 = d2;
            this.d3 = d3;
            this.d4 = d4;
            this.d5 = d5;
            this.ts = ts;
        }
    }

    public class Ctrl
    {

        public string taskId;
        public void settaskId(string taskId)
        {
            this.taskId = taskId;
        }
        public string gettaskId()
        {
            return taskId;
        }
        public List<Ss> ss  { get; set; }
    }
    public class Ctrl2
    {

        public string taskId;
        public void settaskId(string taskId)
        {
            this.taskId = taskId;
        }
        public string gettaskId()
        {
            return taskId;
        }
        public List<Sss> ss { get; set;}
    }


    public class Sss
    {
        public byte addr;
        private Hashtable dn = new Hashtable();
        public Hashtable op
        { get => dn; set => dn = value; }

        public void setAddr(byte addr)
        {
            this.addr = addr;
        }
        public byte getAddr()
        {
            return addr;
        }
    }
    public class Op
    {
        public int duration;
        public long startTime;


        public int d0
        {
            get => D0;
            set => D0 = value;
        }
        public int d1
        {
            get => D1;
            set => D1 = value;
        }
        public int d2
        {
            get => D2;
            set => D2 = value;
        }
        public int d3
        {
            get => D3;
            set => D3 = value;
        }
        public int d4
        {
            get => D4;
            set => D4 = value;
        }

        public int d5
        {
            get => D5;
            set => D5 = value;
        }

        public long ts
        {
            get => Ts;
            set => Ts = value;
        }

        private int D0;
        private int D1;
        private int D2;
        private int D3;
        private int D4;
        private int D5;
        private long Ts;


        public void setDuration(int duration)
        {
            this.duration = duration;
        }
        public int getDuration()
        {
            return duration;
        }

        public void setStartTime(long startTime)
        {
            this.startTime = startTime;
        }
        public long getStartTime()
        {
            return startTime;
        }
   }
    public class Ss
    {
        public byte addr;
        public Op op;
       
        public void setAddr(byte addr)
        {
            this.addr = addr;
        }
        public byte getAddr()
        {
            return addr;
        }
        public void setOp(Op op)
        {
            this.op = op;
        }
        public Op getOp()
        {
            return op;
        }
    }

    public class pcDeviceAlarm
    {
        public const ushort usChannelNumber = 8;
        private const string sAlarmTopic = "Witium/WTDS78X/20193261/Alarm";
        public Hashtable hMqtttAlarmMap = new Hashtable();
        public bool bErrorHasSend = false;
        private string sAlarmJson;
        private string sAlarmJsonPackage;
        //private IMqttClient mqttClient = null;
        public enum eAlarmCode : sbyte
        {
            ChannelNoError = 0,
            ChannelCommunError = 1,
            ChannelCollectDataError = 2,
            ChannelDataRespError = 4,
            ChannelDataChangeError = 8  
        }
        public void vSetAlarmList(ushort usAddress, ushort[] usChannel, eAlarmCode[] usChannelAlarmcode)
        {
            ushort i = 0;
            hMqtttAlarmMap.Add("addr", usAddress.ToString());
            string sAlarm = "alm";
            foreach (ushort usdata in usChannelAlarmcode)
            {
                hMqtttAlarmMap.Add(sAlarm + i, usChannelAlarmcode[i]);
                i++;
            }
            hMqtttAlarmMap.Add("ts", Form1.GetTimeStamp());
            sAlarmJson = JsonConvert.SerializeObject(hMqtttAlarmMap);
        }
        public async Task vPublishAlarmPackageJson(IMqttClient mqttClient)
        {
            sAlarmJson = "[" + sAlarmJson + "]";
            var message = new MqttApplicationMessageBuilder()
                              .WithTopic(sAlarmTopic)
                              .WithPayload(sAlarmJson)
                              .WithAtMostOnceQoS()
                              .WithRetainFlag(false)
                              .Build();
            await mqttClient.PublishAsync(message);
        }
    }
}
