﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ModbusDemo.application
{
    public struct psTemperData
    {
        public byte byModbusID;
        public ushort usTemperRegAddress;
        public ushort usTypeRegAddress;
        public psTemperData(byte bySetModbusID, ushort usSetTempRegAddress, ushort usSetRegAddress)
        {
            this.byModbusID = bySetModbusID;
            this.usTemperRegAddress = usSetTempRegAddress;
            this.usTypeRegAddress = usSetRegAddress;
        }
    }

    public struct psBumpData
    {
        public byte byModbusID;
        public ushort[] usRegAddList;
        public bool[] bOpenStatus;
        public psBumpData(byte byInitModbusID, ushort[] usInitRegAddressInit, bool[] bInitOPen)
        {
            this.byModbusID = byInitModbusID;
            this.usRegAddList = usInitRegAddressInit;
            this.bOpenStatus = bInitOPen;
        }
    }
    public struct psLevel
    {
        public byte byModbusID;
        public ushort[] usDataAddressList;
        public ushort[] usTypeAddressList;
        public psLevel(byte byInitModbusID, ushort[] usDataRegAddress, ushort[] usDataTypeRegAddress)
        {
            this.byModbusID = byInitModbusID;
            this.usDataAddressList = usDataRegAddress;
            this.usTypeAddressList = usDataTypeRegAddress;
        }
    }

    //public struct psPumbPeration
    //{
    //    byte byInitModbusID, ushort[] usInitRegAddressInit, bool[] bInitOPen

    //}

    static  class pcPoolInit
    {
        private static psTemperData sTemper = new psTemperData(1, 2, 3);
        private static ModbusToPool.pcPoolTemperature cPoolTemperature = new ModbusToPool.pcPoolTemperature(sTemper.byModbusID, sTemper.usTemperRegAddress, sTemper.usTypeRegAddress);
        public static double Get_Current_temper()
        {
            cPoolTemperature.vRead_Pumb_Data();
            cPoolTemperature.vRead_Pumb_Type();
            return cPoolTemperature.usReadData[0];
        }
        public const sbyte PoolBumpNumber = 4;

        static ushort[] Data = { 12, 4 };
        static bool[] Regdat = { true, false };
        private static psBumpData psBumpData = new psBumpData(1, Data, Regdat);

        public static ModbusToPool.pcModbusOperationPumb[]  cPumb = new ModbusToPool.pcModbusOperationPumb[PoolBumpNumber] {  new ModbusToPool.pcModbusOperationPumb(psBumpData.byModbusID, psBumpData.usRegAddList,  psBumpData.bOpenStatus),
                                                                                                                       new ModbusToPool.pcModbusOperationPumb(psBumpData.byModbusID, psBumpData.usRegAddList, psBumpData.bOpenStatus) ,
                                                                                                                       new ModbusToPool.pcModbusOperationPumb( psBumpData.byModbusID, psBumpData.usRegAddList, psBumpData.bOpenStatus) ,
                                                                                                                       new ModbusToPool.pcModbusOperationPumb( psBumpData.byModbusID, psBumpData.usRegAddList, psBumpData.bOpenStatus) 
                                                                                                                     };

        //public static void vBumpSetting()
        //{
        //    cPumb[0].vGet_Module_Channel_Status();

        //}

    }
    public class pcAgitator
    {
        private double[] dBumpCurrent;
        public double dBumpVoltage;
        public bool bBumpStatus;
        public bool bAgitatorHasOpen;

        public double[] DBumpCurrent =  new double[pcPoolInit.PoolBumpNumber] { pcPoolInit.cPumb[0].byModbusID, pcPoolInit.cPumb[0].byModbusID , pcPoolInit.cPumb[0].byModbusID , pcPoolInit.cPumb[0].byModbusID };

        public void vOpen_Agitator()
        {

        }
        public void vClose_Agitator()
        {

        }

        public void vGet_Agitator_Status()
        {

        }
    }
    public class pcPoolConfig
    {

        public class pcPool
        {
            public pePondName ePondName;

            public double dMaxlevel;//液位最低水位
            public double dMinlevel;//液位最高水位

            public double dMaxTemper;
            public double dMinTemper;

            public pcPump[] cPump;
            public pcAgitator[] cAgitator;
            public double dPondCurrentLevel;
            public double dPondCurentTemper { get => pcPoolInit.Get_Current_temper(); }
            public pcPool(pePondName eInitPondName)
            {
                this.ePondName = eInitPondName;
            }

        }
    }
}
